=== hecmw1/tools/result_file_merger/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND rmerge_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/fstr_rmerge_util.c
  ${CMAKE_CURRENT_LIST_DIR}/fstr_rmerge.c
)
