=== fistr1/src/lib/utilities/CMakeLists.txt ===
###############################################################################
# Copyright (c) 2019 FrontISTR Commons
# This software is released under the MIT License, see License.txt
###############################################################################

list(APPEND fistr_SOURCES
  ${CMAKE_CURRENT_LIST_DIR}/ttable.f90
  ${CMAKE_CURRENT_LIST_DIR}/utilities.f90
)
